#!/usr/bin/python
import os, sys, time, gc
from qt import *

def report(s):
    print s
    sys.stdout.flush()

def presentMemData(s=""):
    vmsize = vmrss = 0 
    for l in open('/proc/self/status','r').readlines():
        if l.startswith('VmSize:'):
            vmsize = int(l.split()[1])
        elif l.startswith('VmRSS:'):
            vmrss  = int(l.split()[1])
    report(s+"* VmSize: %d VmRss: %d" % (vmsize,vmrss))


class Main(QMainWindow):
    def __init__(self):
        QMainWindow.__init__(self)

    def keyPressEvent(self, event):
        global app
        NUM_FORMS = 4000
        
        k = event.key()
        if k in (QKeyEvent.Key_Enter, QKeyEvent.Key_Return):
            while 1:
              report("\n*** Creating %d QDialog's" % NUM_FORMS)
              presentMemData("Pre-Creating: \n")
              for x in range(NUM_FORMS):
                  # Leaks if the parent is defined or not
                  # and not only with QDialog, but with QPushButton for
                  # example
                  # with QCustomEvent(1) also leaks but at a lesser rate.
                  f = QDialog(self)
                  f = None
              report("End Creating\nForcing GC")
              col   = gc.collect()
              uncol = len(gc.garbage)
              if col or uncol:
                  report("GC Collected: %d Uncollected: %d" % (col, uncol))
              report("End GC")

              presentMemData("Post-Creating: \n")

              app.processEvents()
              presentMemData("Post QApplication::processEvents(): \n")

        elif k == QKeyEvent.Key_M:
            presentMemData()


app = QApplication(sys.argv)

w = Main()
app.setMainWidget(w)
w.show()
report("QT Version:   "+ qVersion())
report("PYQT Version: "+ PYQT_VERSION_STR)
report("SIP Version:  "+ os.popen('sip -V').read())
report("Focus the Window and press Enter for object creation / destruction loop\n")
presentMemData()
app.exec_loop()



